-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
LicensePlatesAddon = {} function LicensePlatesAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(LicensePlates, specializations) end function LicensePlatesAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", LicensePlatesAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", LicensePlatesAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", LicensePlatesAddon) end function LicensePlatesAddon:onLoad(savegame) local spec = self.spec_licensePlates spec.attacherVehicle = nil spec.needLicensePlatesUpdate = true spec.characters = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "-", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", ",", ".", ":", "!", "?", "%", "&amp;", "#", "+"} spec.tractorPlateCharacter = self.xmlFile:getValue("vehicle.variableWorkWidth.variableWorkWidthConfigurations.variableWorkWidthConfiguration(1).objectChange(0)#node", nil, self.components, self.i3dMappings) spec.trailerPlateCharacter = self.xmlFile:getValue("vehicle.variableWorkWidth.variableWorkWidthConfigurations.variableWorkWidthConfiguration(1).objectChange(1)#node", nil, self.components, self.i3dMappings) spec.tractorPlateCharacterConsole = self.xmlFile:getValue("vehicle.variableWorkWidth.variableWorkWidthConfigurations.variableWorkWidthConfiguration(1).objectChange(2)#node", nil, self.components, self.i3dMappings) spec.trailerPlateCharacterConsole = self.xmlFile:getValue("vehicle.variableWorkWidth.variableWorkWidthConfigurations.variableWorkWidthConfiguration(1).objectChange(3)#node", nil, self.components, self.i3dMappings) spec.tractorPlate = self.xmlFile:getValue("vehicle.variableWorkWidth.variableWorkWidthConfigurations.variableWorkWidthConfiguration(1).objectChange(4)#node", nil, self.components, self.i3dMappings) spec.characterNode = {} for i = 0, 6 do local entry = {} entry.node = getChildAt(spec.tractorPlateCharacter, i) table.insert(spec.characterNode, entry) end for i = 0, 6 do local entry = {} entry.node = getChildAt(spec.trailerPlateCharacter, i) table.insert(spec.characterNode, entry) end local configurationId = Utils.getNoNil(self.configurations.variableWorkWidth, 1) if configurationId == 1 then setVisibility(spec.tractorPlate, false) SpecializationUtil.removeEventListener(self, "onUpdateTick", LicensePlatesAddon) SpecializationUtil.removeEventListener(self, "onPostAttach", LicensePlatesAddon) end end function LicensePlatesAddon:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_licensePlates if g_licensePlateManager:getAreLicensePlatesAvailable() and self.getLicensePlatesData ~= nil and spec.needLicensePlatesUpdate then local data = self:getLicensePlatesData() if data ~= nil and data.characters ~= nil then for i = 1, 7 do if data.characters[i] == "_" then setVisibility(spec.characterNode[i+7].node, false) else setVisibility(spec.characterNode[i+7].node, true) for c = 1, #spec.characters do if data.characters[i] == spec.characters[c] then setShaderParameter(spec.characterNode[i+7].node, "index", c-1, 0, 0, 0, false) end end end end else local currentCharacters = g_currentMission:getLastCreatedLicensePlate() or g_licensePlateManager:getRandomLicensePlateData() for i = 1, 7 do if currentCharacters.characters[i] == "_" then setVisibility(spec.characterNode[i+7].node, false) else setVisibility(spec.characterNode[i+7].node, true) for c = 1, #spec.characters do if currentCharacters.characters[i] == spec.characters[c] then setShaderParameter(spec.characterNode[i+7].node, "index", c-1, 0, 0, 0, false) end end end end end setVisibility(spec.tractorPlateCharacter, true) setVisibility(spec.trailerPlateCharacter, true) setVisibility(spec.tractorPlateCharacterConsole, false) setVisibility(spec.trailerPlateCharacterConsole, false) spec.needLicensePlatesUpdate = false end end function LicensePlatesAddon:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex, loadFromSavegame) local spec = self.spec_licensePlates spec.attacherVehicle = self:getRootVehicle() if spec.attacherVehicle:getMotor().maxBackwardSpeed == nil then spec.attacherVehicle = nil end if spec.attacherVehicle.spec_licensePlates.licensePlateData.characters == nil then setVisibility(spec.tractorPlate, false) else for place = 1, 2 do if spec.attacherVehicle.spec_licensePlates.licensePlates[place].data.characters ~= nil then for i = 1, 7 do if spec.attacherVehicle.spec_licensePlates.licensePlates[place].data.characters[i] == "_" then setVisibility(spec.characterNode[i].node, false) else setVisibility(spec.characterNode[i].node, true) for c = 1, #spec.characters do if spec.attacherVehicle.spec_licensePlates.licensePlates[place].data.characters:sub(i, i) == spec.characters[c] then setShaderParameter(spec.characterNode[i].node, "index", c-1, 0, 0, 0, false) end end end end end end setVisibility(spec.tractorPlate, true) end end function LicensePlatesAddon:updateDebugValues(values) local spec = self.spec_licensePlates if spec.licensePlateData ~= nil then if spec.licensePlateData.characters ~= nil then table.insert(values, {name="number of characters", value=#spec.licensePlateData.characters}) end end if spec.licensePlates[1] ~= nil then table.insert(values, {name="characters 1", value=spec.licensePlates[1].data.characters}) end if spec.licensePlates[2] ~= nil then table.insert(values, {name="characters 2", value=spec.licensePlates[2].data.characters}) end if spec.attacherVehicle ~= nil then if spec.attacherVehicle.spec_licensePlates.licensePlateData ~= nil then if spec.attacherVehicle.spec_licensePlates.licensePlateData.characters ~= nil then table.insert(values, {name="attacherVehicle number of characters", value=#spec.attacherVehicle.spec_licensePlates.licensePlateData.characters}) end if spec.attacherVehicle.spec_licensePlates.licensePlates[1] ~= nil then table.insert(values, {name="attacherVehicle characters 1", value=spec.attacherVehicle.spec_licensePlates.licensePlates[1].data.characters}) end if spec.attacherVehicle.spec_licensePlates.licensePlates[2] ~= nil then table.insert(values, {name="attacherVehicle characters 2", value=spec.attacherVehicle.spec_licensePlates.licensePlates[2].data.characters}) end end end end